/////////////////////////////////////////////////////////////////////////////////  
//Programm "Dynamische Geometrie" (hier in der Version mit Schnittpunkten,
//VertexCurve und BezierCurve )
//Aufgabe 3 im Kapitel Raeumliche Formen
/////////////////////////////////////////////////////////////////////////////
//Attribute:
////////////////////////////////////////////////////////////////////////
private ArrayList<GeoObject> geoObjects = new ArrayList<GeoObject>();
private ArrayList<Point> selectedPoints= new ArrayList<Point>();
private ArrayList<Point> fixPoints= new ArrayList<Point>();

private Point dPoint = null;


private int w, h;
private int r,g,b;
///////////////////////////////////////////////
//In setup und draw gibt es nicht viel zu tun!
///////////////////////////////////////////////
void setup() {
 w = 1000; h = 800;
 surface.setSize(w,h);
}

void draw() {
  background(255);
  for (GeoObject go : geoObjects ) {
    go.display(); 
  } 
}

//Wird in der Nähe eines vorhandenen Punktes links-geklickt,...
//Die mousePressed-Methode ist im Skript ausführich erklärt
void mousePressed() {  
  if( mouseButton == LEFT){
  dPoint = null;
  for (GeoObject go : geoObjects ) {
    if (go instanceof Point ){
      Point p = (Point) go;
      double d = p.abstandZu(mouseX, mouseY);
      if (d < 6 &&  !fixPoints.contains(p)) {
        dPoint = p; 
      }
    } 
  }  
  if (dPoint == null) {
    Point newPoint = new Point(mouseX, mouseY);
    newPoint.setfarbe(color(r,g,b));//kann weggelassen werden, wenn Punkte grundsätzlich schwarz gezeichnet werden sollen
    geoObjects.add(newPoint);    
  }  else {
     if(keyPressed == true && key == TAB){
        if (dPoint.getSelected()) {
          dPoint.setSelected(false);
          selectedPoints.remove(dPoint);
        } else {
          dPoint.setSelected(true);
          selectedPoints.add(dPoint);
        }
     }    
   }
  }
  
}
//Methode sorgt dafür, dass beim Löschen eines Punktes keine Lines ohne Punkte gezeichnet werden          
public void deleteObjects(){
   ArrayList<GeoObject> objekteZuLoeschen = new ArrayList<GeoObject>();
   for (Point p : selectedPoints) {     
      objekteZuLoeschen.add(p);             
      for (GeoObject o : geoObjects) { 
        if (o.abhaengigVon(p)) {         
          objekteZuLoeschen.add(o);        
        } 
       }
      }                                                     
   for (GeoObject o : objekteZuLoeschen) {   
      geoObjects.remove(o);           
   } 
}

 //Der Punkt wird zum dPoint und kann verschoben werden 
 //Aber nur dann, wenn nicht eine Gerade markiert werden soll( rechter Mause-Button).
public void mouseDragged() {
  if(dPoint != null  && ! (mouseButton == RIGHT)) {
    dPoint.setX(mouseX);
    dPoint.setY(mouseY);
  } 
}


//Damit wählt man das zu zeichnende Objekt bzw. die Farbe des Objekts 
void keyPressed(){
  
  //VertexCurve erzeugen
   if (key == 'v'){
   if (selectedPoints.size() >= 3) {    
      VertexCurve vertexCurve = new VertexCurve(selectedPoints);
     // Farbe ist fest eingestellt
      geoObjects.add(vertexCurve);
    } 
    selectedPointsLoeschen();
  } 
  
  //BezierCurve erzeugen
   if (key == 'x'){
   if (selectedPoints.size() == 4) {    
      BezierCurve bezierCurve = new BezierCurve(selectedPoints);
     // Farbe ist fest eingestellt
      geoObjects.add(bezierCurve);
    } 
    selectedPointsLoeschen();
  } 
  
  
  //Punkt löschen
  if (key == 'd'){
   if (selectedPoints.size() >= 0) {
      deleteObjects();
    } 
    selectedPointsLoeschen();
   } 
  
}//Ende keyPressed()


//markierte Punkte löschen
private void selectedPointsLoeschen(){
 for (Point p: selectedPoints) {
      p.setSelected(false);
 } 
 selectedPoints.clear();
 }



 

   
    

 
 
 
 
 
 
 